#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct Psd {
    #[builder(custom(type = super::NumericSeries, convert = Box::new))]
    #[serde(rename = "input")]
    input: Box<super::NumericSeries>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::StftOptions>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "stftOptions", skip_serializing_if = "Option::is_none", default)]
    stft_options: Option<Box<super::StftOptions>>,
    #[builder(default, into)]
    #[serde(
        rename = "magnitudeScaling",
        skip_serializing_if = "Option::is_none",
        default
    )]
    magnitude_scaling: Option<super::MagnitudeScaling>,
    #[builder(default, into)]
    #[serde(
        rename = "outputFrequencyType",
        skip_serializing_if = "Option::is_none",
        default
    )]
    output_frequency_type: Option<super::OutputFrequencyType>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::FrequencySummarizationStrategy>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(
        rename = "summarizationStrategy",
        skip_serializing_if = "Option::is_none",
        default
    )]
    summarization_strategy: Option<Box<super::FrequencySummarizationStrategy>>,
}
impl Psd {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(input: super::NumericSeries) -> Self {
        Self::builder().input(input).build()
    }
    #[inline]
    pub fn input(&self) -> &super::NumericSeries {
        &*self.input
    }
    #[inline]
    pub fn stft_options(&self) -> Option<&super::StftOptions> {
        self.stft_options.as_ref().map(|o| &**o)
    }
    /// The scaling to apply to the output magnitude. Defaults to MAGNITUDE_DB_10 if not specified.
    #[inline]
    pub fn magnitude_scaling(&self) -> Option<&super::MagnitudeScaling> {
        self.magnitude_scaling.as_ref().map(|o| &*o)
    }
    /// The type of the output frequency. Defaults to LINEAR if not specified. Changing the output frequency unit
    /// may also rescale the magnitude of the output in order to ensure the density of the output is consistent.
    #[inline]
    pub fn output_frequency_type(&self) -> Option<&super::OutputFrequencyType> {
        self.output_frequency_type.as_ref().map(|o| &*o)
    }
    /// Strategy to downsample the output frequency spectrum.
    #[inline]
    pub fn summarization_strategy(
        &self,
    ) -> Option<&super::FrequencySummarizationStrategy> {
        self.summarization_strategy.as_ref().map(|o| &**o)
    }
}
